#!/usr/bin/env bash

#*****************************************************************************
# xtmvavg.sh version 1.0b
# ưʿѻХץ
# Y.Hamuro
# 2004/05/07
#*****************************************************************************

function help {
cat >/dev/stderr <<EOF
--------------------------
xtmvavg.sh version 1.0b
--------------------------
) ưʿѤ׻롣
) xtmvavg.sh -s ¤ٴ̾ꥹ -f ׹̾ -n ư
                 -a ̾ [-i ϥե̾] [-oϥե̾]
                  [-T ǥ쥯ȥ̾] [-V] [-h]
        -V : ޥɤδλåɽ롣
        -h : إפɽ

1) xtmvavg.sh -s  -f  -n 3 -a ưʿ -i input.xt -o output.xt
2) xtmvavg.sh -s %r -f , -n 5 -a ưʿ -i input2.xt -o output2.xt
3) xtmvavg.sh -s ǯ, -f  -n 4 -a ưʿ <input3.xt >output3.xt

1ϥǡ
--------------
input.xt
--------------
 
1 10
2 20
3 30
4 40
5 50
--------------
output.xt
--------------
  ưʿ
1 10 *
2 20 *
3 30 20
4 40 30
5 50 40
--------------
3 : (10+20+30)/3 = 20
4 : (20+30+40)/3 = 30
5 : (30+40+50)/3 = 40
EOF
exit 1
}

export mssQuiet=1

#ѥ᡼Υåå
while getopts ":s:f:n:a:i:o:T:Vh" opt; do
  case $opt in
    s  ) SORT=$OPTARG ;;
    f  ) FLD=$OPTARG ;;
    n  ) MVCNT=$OPTARG ;;
    a  ) NEWFLD=$OPTARG ;;
    i  ) INPUT=$OPTARG ;;
    o  ) OUTPUT=$OPTARG ;;
    T  ) TMPD=$OPTARG ;;
    V  ) mssQuiet=0 ;;
    h  ) help ;;
    \? ) help ;;
  esac
done
shift $(($OPTIND -1 ))

if [ "$SORT" = "" ]; then
  echo "#MSG# $$ \"xtmvavg.sh\" \"option -s is mandatory\"" >/dev/stderr
  help; exit 1
fi
if [ "$FLD" = "" ]; then
  echo "#MSG# $$ \"xtmvavg.sh\" \"option -f is mandatory\"" >/dev/stderr
  help; exit 1
fi
if [ "$MVCNT" = "" ]; then
  echo "#MSG# $$ \"xtmvavg.sh\" \"option -n is mandatory\"" >/dev/stderr
  help; exit 1
fi
if [ "$NEWFLD" = "" ]; then
  echo "#MSG# $$ \"xtmvavg.sh\" \"option -a is mandatory\"" >/dev/stderr
  help; exit 1
fi
if [ "$INPUT" = "" ]; then
   INPUT=/dev/stdin
fi
if [ "$OUTPUT" = "" ]; then
 OUTPUT=/dev/stdout
fi
if [ "$TMPD" = "" ]; then
   TMPD=/tmp
fi

SORTFLD=${SORT%\%*}
SORTPAR=${SORT#*%}
if [ "$SORTFLD" = "$SORTPAR" ]; then
  SORTPAR=""
else
  SORTPAR="%$SORTPAR"
fi

TD=$TMPD/xxx$$

#=====================================================
# ڥƥåף
# ϥեγƹԤư(-n)ʬduplicate
# ǤϢֹ(##mvSeq##)롣
# Ϣ֤ϴʤ˳ֹ򤺤餷Ƥ
#-----------------------------------------------------
#    ($INPUT: ʲιȤϤϥǡˤƤ)
# 1 10
# 2 20
# 3 30
# 4 40
# 5 50
#  
#   ##mvSeq##  ($TD-xxbase)
# 1 10 1001
# 1 10 1002
# 1 10 1003
# 2 20 1002
# 2 20 1003
# 2 20 1004
# 3 30 1003
# 3 30 1004
# 3 30 1005
# 4 40 1004
# 4 40 1005
# 4 40 1006
# 5 50 1005
# 5 50 1006
# 5 50 1007
#=====================================================
xtnumber -s $SORTFLD$SORTPAR -S 1000 -a '##seqNo##' -i $INPUT |
xtsetchr -v $MVCNT -a days |
xtduprec -f days |
xtcal -k '##seqNo##' -c '$##seqNo##+keyLine()' -a '##mvSeq##' |
xtcut -r -f 'days,##seqNo##' -o $TD-xxbase

#=====================================================
# ڥƥåף
# Υƥåף##mvSeq##򥭡ˤưưʿѤ뤬
# κݡư(-n)ʤΤϰ̣
# ʤ
# Ƿư(-n)##mvSeq##Ǥ
#-----------------------------------------------------
# ##mvSeq## ##cnt##  ($TD-xx2)
# 1003 3
# 1004 3
# 1005 3
#=====================================================
xtcut   -f '##mvSeq##' -i $TD-xxbase | 
xtcount -k '##mvSeq##' -a '##cnt##' |
xtsel   -c '$##cnt##=='$MVCNT -o $TD-xx2

#=====================================================
# ڥƥåף
# ##mvSeq##򥭡ˤưưʿѤ롣
# κݡ嵭ǵ᤿##mvSeq##ηư(-n)
# ԤΤߤ֡
#-----------------------------------------------------
# ##mvSeq## ##cnt##  ($TD-xx3)
# 1003 20
# 1004 30
# 1005 40
#=====================================================
xtcut    -f '##mvSeq##',$FLD -i $TD-xxbase |
xtagg    -k '##mvSeq##' -f $FLD:$NEWFLD -c avg |
xtcommon -k '##mvSeq##' -m $TD-xx2 -o $TD-xx3

#=====================================================
# ڥƥåף
# ƥåףǵ᤿ǡ顢##mvSeqб
# 򤷡ƥåףǵ᤿ưʿͤ礹롣
#-----------------------------------------------------
# ,,ưʿ ($OUTPUT)
# 1 10 *
# 2 20 *
# 3 30 20
# 4 40 30
# 5 50 40
#=====================================================
xtcut  -f '##mvSeq##',$SORTFLD,$FLD -i $TD-xxbase |
xtbest -k $SORTFLD -s '##mvSeq##' -R 1 |
xtjoin -n -k '##mvSeq##' -m $TD-xx3 -f $NEWFLD |
xtcut  -r -f '##mvSeq##' -o $OUTPUT

rm $TD-xx*
#===============================================================
